#!/usr/bin/env node
"use strict";
/**
 * merge-package-locks
 * Merge two package locks
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const t = __importStar(require("io-ts"));
const E = __importStar(require("fp-ts/Either"));
const NEA = __importStar(require("fp-ts/NonEmptyArray"));
const F = __importStar(require("fluture"));
const D = __importStar(require("io-ts-docopt"));
const io_ts_docopt_1 = require("io-ts-docopt");
const PathReporter_1 = require("io-ts/lib/PathReporter");
const function_1 = require("fp-ts/function");
const Semigroup_1 = require("fp-ts/lib/Semigroup");
const nonEmptyArray_1 = require("io-ts-types/lib/nonEmptyArray");
const lerna_utils_1 = require("@typescript-tools/lerna-utils");
const stringify_json_1 = require("@typescript-tools/stringify-json");
const PackageLockJson_1 = require("@typescript-tools/io-ts/dist/lib/PackageLockJson");
const trace_1 = require("@strong-roots-capital/trace");
const debug_1 = __importDefault(require("debug"));
const debug = {
    cmd: debug_1.default('merge')
};
const docstring = `
Usage:
    merge-package-locks <target> <source>...

Options:
    <target>    Target package-lock.json in which to accumulate information
    <source>    List of package-lock.json files to merge into <target>

Note: only supports lockfileVersion v1 for now (npm version 6)
`;
const CommandLineOptions = io_ts_docopt_1.withEncode(t.type({
    '<target>': t.string,
    '<source>': nonEmptyArray_1.nonEmptyArray(t.string),
}), a => ({
    target: a['<target>'],
    sources: a['<source>'],
}));
// Temporary helper to infer types, see https://github.com/fluture-js/Fluture/issues/455
function map(mapper) {
    return F.map(mapper);
}
// Widens the type of a particular Err into an Err
const error = (error) => error;
const decodeDocopt = (codec, docstring) => function_1.pipe(D.decodeDocopt(codec, docstring), E.mapLeft((err) => ({ type: 'docopt decode', err: PathReporter_1.PathReporter.report(E.left(err)).join('\n') })), E.map(options => F.resolve(options)), E.getOrElse(err => F.reject(err)));
const readFile = (file) => function_1.pipe(lerna_utils_1.readFile(file), F.mapRej(err => error({ type: 'unable to read file', file, err })));
const parseJson = (file) => (contents) => function_1.pipe(E.parseJSON(contents, E.toError), E.map(F.resolve), E.getOrElseW(err => F.reject(error({ type: 'unable to parse file', file, err }))));
const decodeFile = (file) => (contents) => function_1.pipe(PackageLockJson_1.PackageLockJson.decode(contents), E.mapLeft(errors => PathReporter_1.PathReporter.report(E.left(errors)).join('\n')), E.map(F.resolve), E.getOrElseW(err => F.reject(error({ type: 'unexpected file contents', file, err }))));
const stringifyJSON = (onError) => (json) => function_1.pipe(stringify_json_1.stringifyJSON(onError)(json), E.map(F.resolve), E.getOrElseW(err => F.reject(error({ type: 'unable to stringify json', json, err }))));
const writeFile = (file) => (contents) => function_1.pipe(contents, trace_1.trace(debug.cmd, `Writing file ${file}`), lerna_utils_1.writeFile(file), F.mapRej(err => error({ type: 'unable to write file', file, err })));
// FEATURE: do not write a file that hasn't changed
// FEATURE: support npm 7 lockfiles
function main() {
    function_1.pipe(decodeDocopt(CommandLineOptions, docstring), F.chain(options => function_1.pipe(NEA.cons(options.target, options.sources), NEA.map(file => function_1.pipe(readFile(file), F.chain(parseJson(file)), F.chain(decodeFile(file)))), F.parallel(Infinity), map(([target, ...sources]) => Semigroup_1.fold(PackageLockJson_1.PackageLockJsonSemigroup)(target, sources)), F.chain(stringifyJSON(E.toError)), F.chain(writeFile(options.target)))), F.fork(error => (console.error(error), process.exit(1)))(function_1.constVoid));
}
main();
// Local Variables:
// mode: typescript
// End:
//# sourceMappingURL=index.js.map